; Copyright (C) 2014-2020 Joonas Javanainen <joonas.javanainen@gmail.com>
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.

; This test checks when writes to the TMA register get picked while
; the timer is reloading.

; Verified results:
;   pass: DMG, MGB, SGB, SGB2, CGB, AGB, AGS
;   fail: -

.include "common.s"

test:
  di
  xor a
  ld b,$fe
  ld h,$7f
  ldh (<IE), a
  ldh (<IF), a
  ldh (<DIV), a
  ld a, b
  ldh (<TIMA), a
  ldh (<TMA),a
  ld a, %00000110 ; Start 65536 Hz timer (64 cycles)
  ldh (<TAC), a
  ld a,b
  ldh (<DIV),a
  ldh (<TIMA), a
  ldh (<DIV),a
  ld a,h
  nops 16
  nops 12
  ldh (<TMA),a
  ldh a,(<TIMA)
  ld d,a

  ld a,b
  ldh (<TIMA), a
  ldh (<TMA),a
  ldh (<DIV),a
  ldh (<TIMA), a
  ldh (<DIV),a
  ld a,h
  nops 16
  nops 13
  ldh (<TMA),a
  ldh a,(<TIMA)
  ld e,a

  ld a,b
  ldh (<TIMA), a
  ldh (<TMA),a
  ldh (<DIV),a
  ldh (<TIMA), a
  ldh (<DIV),a
  ld a,h
  nops 16
  nops 14
  ldh (<TMA),a
  ldh a,(<TIMA)
  ld c,a

  ld a,b
  ldh (<TIMA), a
  ldh (<TMA),a
  ldh (<DIV),a
  ldh (<TIMA), a
  ldh (<DIV),a
  ld a,h
  nops 16
  nops 15
  ldh (<TMA),a
  ldh a,(<TIMA)
  ld l,a

  setup_assertions
  assert_c $fe
  assert_d $7f
  assert_e $7f
  assert_l $fe
  quit_check_asserts

